using adas_core.Domain.Models;
using MongoDB.Bson;
using MongoDB.Driver;

namespace adas_core.Application.Repositories.Interfaces;

public interface IDiagnosisRepository : IMongoRepository<PatientDiagnosis>
{
    Task<List<PatientDiagnosis>> GetByPatient(ObjectId patientId);

    new Task InsertOneAsync(PatientDiagnosis diagnosis);
    new Task DeleteAsync(ObjectId id);
    Task UpdateManyObjectId(string nameId, ObjectId id, ObjectId oldId);
    Task<IAsyncCursor<PatientDiagnosis>> FindByPatientIdAsync(ObjectId patientId);
    Task DeleteByPatientId(ObjectId patientId);
    Task<PatientDiagnosis?> FindByPatientIdAndCode(ObjectId patientId, string? diagnosisCode, string? codingSystem);
}